#ifndef __IUF_AST3DBONUS
#define __IUF_AST3DBONUS
/** This class represent a asteroid with a 3D random fractal shape.
The fractal shape is stored in a mesh and it is generated, starting 
from a loaded base mesh (i.e. ast.raw or tetra.raw) and
by recursively subdividing each face into four smaller faces.
Version History {\small 
\begin{itemize}
\item 0.4s Added the Explode and GenerateSub 
\item 0.5s Added texture mapping. It involved the creation of a static
 variable SharedTexture and a static function SetSharedTexture to use 
 a common texture among all the asteroids. 
 For a similar reason we have added a constructor that starts from 
 a given mesh instead of a file. Modified also the GenerateSub() in order to start the fractal generation from a previously loaded mesh.

\end{itemize}
}
*/
class Ast3DBonus: public Ast
{ 
public:
Ast3DBonus::Ast3DBonus(Mesh &mm,float _size=5, int recur=1,int seed=-1);
void GenerateSub(Mesh &AstM);
void Ast3DFract::Explode(list<Ast *> &AL, list<GameObj *> &OL)
{
};

};