#ifndef __IUF_GAMEINTRO
#define __IUF_GAMEINTRO

#include <vcg/Point3.h>
#include <list>
#include "GameSection.h"
#include "GameIntro.h"
#include "Triangle.h"
#include "Ast3DFract.h"
#include "Stars.h"

/** This class represent the intro of the game.
A rotating title between asteroids flying against observer.
Version History {\small 
\begin{itemize}
\item 0.4 First Release.
\item 0.6 Added three Level of details to represent the asteroids, modified Draw to choose the right lod to draw.
\end{itemize}
}


*/

using namespace vcg;
using namespace std;
class GameIntro:public GameSection
{
 public:
	 GameIntro();

 /** Default Number of Asteroids in the intro
 @name AstNum=16
  */
 enum {AstNum=64};

 /** Manage key pression.
 */
 void Key(unsigned char key);
 
 /** The Mesh of the rotating Title
 */
 Mesh Title;

 /** All the flying asteroids.Modified in version 6 to store lo, med, and hi res asteroids

	@name vector<Ast3DFract *> A
	 */
	vector<Ast3DFract *> A[3];

	Stars s;

 /// Initializing Stuff
 void Init(int score=0,int liv=0);
 /** Draw the Rotating Title, with flying asteroids and the "press key..." string
 For each asteroid to be drawn we choose the right lod according its z distance from the
 observer.
 */
 int Draw();
 /** Typical Reshape.
 Very similar to \Ref{GameSession}
 */
 void Reshape(int w, int h);
 
 /** Typical Update.
 Move the asteroids and clip them against the view frustum.
 */
 void Update(int dt);

 /** Clip asteroids agains view frustum.
 Every frame we clip the ast position against the view frustum,
 when an ast is outside the view frustm it is moved again far away.
 In this way we are sure that we draw only what we can see.
 */
 void Clip(Point3f &p);
};

#endif